﻿Imports System.IO

Module Module1

    Public Sub main()
        ' Get user input for folder name and path
        Dim input As String = InputBox("Enter the name for the new folder", "Folder Name")
        Dim path As String = InputBox("Enter the location for this new folder", "Folder Location", "C:\Windows\Desktop")
        Dim folderName As String = IO.Path.Combine(path, input)

        ' Create the new folder
        If Not Directory.Exists(path) Then
            MessageBox.Show("The specified path does not exist.")
            Return
        End If
        Directory.CreateDirectory(folderName)

        ' Get user input for the icon
        Dim where As String = InputBox("Enter the file and index where the icon can be found", "Icon", "C:\windows\moricons.dll,22")
        Dim folderIcon As String = where

        ' Create desktop.ini and write settings
        Dim iniPath As String = IO.Path.Combine(folderName, "desktop.ini")
        Using writer As New StreamWriter(iniPath)
            writer.WriteLine("[.ShellClassInfo]")
            writer.WriteLine("IconResource=" & folderIcon)
        End Using

        ' Set file attributes: hidden, system, and read-only for desktop.ini
        SetFileAttributes(iniPath, FileAttributes.Hidden Or FileAttributes.System Or FileAttributes.ReadOnly)
        SetFileAttributes(folderName, FileAttributes.Hidden Or FileAttributes.System)

        ' Notify the user
        MessageBox.Show("You may need to select the new folder or reboot to see the correct icon.")
    End Sub

    Private Sub SetFileAttributes(filePath As String, attributes As FileAttributes)
        File.SetAttributes(filePath, attributes)

        ' If using CMD for attributes
        Dim process As New Process()
        process.StartInfo.FileName = "cmd.exe"
        process.StartInfo.Arguments = "/c attrib " & attributes.ToString() & " """ & filePath & """"
        process.StartInfo.CreateNoWindow = True
        process.StartInfo.UseShellExecute = False
        process.Start()
        process.WaitForExit()
    End Sub

End Module
